//
package dfs

import (
	"crypto/sha1"
	"encoding/base32"

	"log"
	"os"
)

const (
	HASHLEN     = 32
	THE_PRIME   = 31
	MINCHUNK    = 2048
	TARGETCHUNK = 4096
	MAXCHUNK    = 8192
)

var b uint64
var saved [256]uint64

func p_out(s string, args ...interface{}) {
	if !debug {
		return
	}
	log.Printf(s, args...)
}

func p_err(s string, args ...interface{}) {
	log.Printf(s, args...)
	os.Exit(1)
}

//=============================================================================
func initStore(newfs bool, dbPath string) {

}

// returns len of next chunk
func rkChunk(buf []byte) int {

	// ...
}

// return base32 (stringified) version of sha1 hash of array of bytes
func shaString(buf []byte) string {

	// ...

}

// Use rk fingerprints to chunkify array of data. Take the
// stringified sha1 hash of each such chunk and use as key
// to store in underlying file system. Return array of such strings.
func putBlocks(data []byte) []string {

	// ...

}

// puts a block of data at key defined by hash of data. Return ASCII hash.
func putBlock(data []byte) string {

	// ...

}

// store data at a specific key, used for "head"
func putBlockSig(s string, data []byte) error {

	// ...

}

// []byte or nil
func getBlock(key string) []byte {

	// ...

}


// Parse a local time string in the below format.
func parseLocalTime(tm string) (time.Time, error) {
	loc, _ := time.LoadLocation("America/New_York")
	return time.ParseInLocation("2006-1-2T15:04:05", tm, loc)
}

